<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	require_once dirname(__FILE__).'/../lib/PageGlobal.php';
	require_once $twatch->path( 'lib/AdminPage.php' );
	
	$twatch->makeParentClass( 'AdminLatestPage', 'TwatchAdminPage' );
	
	class AdminLatestPage extends AdminLatestPageParent {
		
		protected function includeBaseJs() {
			global $twatch;
			parent::includeBaseJs();
			$this->inHead->pl( '<script type="text/javascript" src="'.$twatch->baseUrl( $this->toRoot, 'js/ArdeExpression.js' ).'"></script>' );
		}
		
		public function render( ArdePrinter $p ) {
			global $twatch, $ardeBase;
			
			require_once $twatch->path( 'data/DataLatest.php' );
			
			$this->title = 'Admin: Latest Visitors Page';
			$this->toRoot = '..';
			
			$this->init();
			
			
			$this->inHead->pl( '<script type="text/javascript" src="../js/AdminLatest.js"></script>' );
			
			$this->selected_left_button = 3;
			
			$this->addExtraConfig( TwatchLatestPage::$defaults );
			
			$this->open( $p );
			
			
			
			$entities = &$twatch->config->getList( TwatchConfig::ENTITIES );
			$latestPage = $twatch->config->get( TwatchConfig::LATEST_PAGE );
			$latest = $twatch->config->get( TwatchConfig::LATEST );
			$dataWriters = $twatch->config->getList( TwatchConfig::RDATA_WRITERS );
			
			$ents = new ArdeAppender( ', ' );
			foreach( $entities as $entity ) {
				$ents->append( $entity->id.": '".ArdeJs::escape( $entity->name )."'" );
			}
			$p->pl( '<h1>Latest Visitors</h1>' );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/', 1 );
			$this->initJsPage( $p );
			TwatchEntityView::InitJs( $p );
			TwatchExpression::printJsInputElements( $p );
			$p->rel();
			$p->pl( '	entities = { '.$ents->s.' };' );
			$p->pl( '	adminLatest = '.$latest->jsObject().';' );
			$p->pl( '	adminLatest.insert();' );
			$p->pl( '/*]]>*/</script>' );
			$p->pl( '<h1>Latest Visitors Page</h1>' );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/' );
			$vts = new ArdeAppender( ', ' );
			foreach( $twatch->config->getList( TwatchConfig::VISITOR_TYPES ) as $visitorType ) {
				$vts->append( $visitorType->id.': '.$visitorType->jsObject() );
			}
			$p->pl( '	vTypes = { '.$vts->s.' };' );
			$p->pl( '	adminLatestPage = '.$latestPage->adminJsObject().';' );
			$p->pl( '	adminLatestPage.insert();' );
			$p->pl( '/*]]>*/</script>' );
			$p->pl( '<h1>Data Writers</h1>' );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/' );
			$p->pl( '	dataWritersHolder = new DataWritersHolder();' );
			$p->pl( '	dataWritersHolder.insert();', 0 );
			foreach( $dataWriters as $dataWriter ) {
				$p->pl( 'dataWritersHolder.addItem( '.$dataWriter->jsObject().' );' );
			}
			$p->rel();
			$p->pl( '/*]]>*/</script>' );
			$this->close( $p );
		}
		
	}
	
	$twatch->applyOverrides( array( 'AdminLatestPage' => true ) );
	
	$page = $twatch->makeObject( 'AdminLatestPage' );
	$page->render( $p );
?>