<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	$adminConfig = true;
	require_once dirname(__FILE__).'/../../lib/RecGlobalHead.php';
	require_once $ardeBase->path( 'lib/ArdeXml.php' );
	require_once $twatch->path( 'lib/Import.php' );

	loadConfig();
	
	
	
	if( !isset( $_POST['a'] ) ) throw new TwatchException( 'Action was not sent' );

	if( $_POST['a'] == 'read' ) {
		set_time_limit( 100 );
		$fileName = ArdeParam::str( $_POST, 'f' );
		if( !file_exists( $twatch->path( 'store/'.$fileName ) ) ) throw new TwatchException( 'file "'.$fileName.'" doesn\'t exist' );
		$rootElement = ArdeXml::fileRoot(  $twatch->path( 'store/'.$fileName ) );
		$fileInfo = TwatchImportFileInfo::fromXml( $rootElement );
		$fileInfo->name = $fileName;
		if( !$xhtml ) {
			$fileInfo->printXml( $p, 'result' );
			$p->nl();
		}
	} elseif( $_POST['a'] == 'list_dir' ) {
		$files = array();
		$dir = opendir( $twatch->path( 'store' ) );
		while( $file = readdir( $dir ) ) {
			if( $file == '..' || $file == '.' ) continue;
			$files[] = $file;
		}
		if( !$xhtml ) {
			$p->pl( '<result>', 1 );
			foreach( $files as $file ) {
				$p->pl( '<file>'.ardeXmlEntities( $file ).'</file>' );	
			}
			$p->rel();
			$p->pl( '</result>' );
		}
	} elseif( $_POST['a'] == 'import' ) {
		
		set_time_limit( 600 );
		$fileName = ArdeParam::str( $_POST, 'n' );
		if( !file_exists( $twatch->path( 'store/'.$fileName ) ) ) throw new TwatchException( 'file "'.$fileName.'" doesn\'t exist' );
		
		$progressChannelId = ArdeParam::int( $_POST, 'ch', 0 );
		
		$websiteId = ArdeParam::int( $_POST, 'w' );
		if( !$twatch->config->propertyExists( TwatchConfig::WEBSITES, $websiteId ) ) {
			throw new TwatchException( 'website '.$websiteId.' does not exist.' );
		}
		$website = $twatch->config->get( TwatchConfig::WEBSITES, $websiteId );
		if( $website->parent ) {
			throw new TwatchException( 'data cannot be imported into sub-websites.' );
		}
		
		$counterCount = ArdeParam::int( $_POST, 'cc', 0 );
		$counterMap = array();
		for( $i = 0; $i < $counterCount; ++$i ) {
			$name = ArdeParam::str( $_POST, 'c'.$i.'_n' );
			$counterId = ArdeParam::int( $_POST, 'c'.$i.'_mi' );
			if( !$twatch->config->propertyExists( TwatchConfig::COUNTERS, $counterId ) ) {
				throw new TwatchException( 'counter '.$counterId.' does not exist' );
			}
			if( !$twatch->config->get( TwatchConfig::COUNTERS, $counterId )->allowImport() ) {
				throw new TwatchException( 'counter '.$counterId.' doesn\'t allow import' );
			}
			$counterMap[ $name ] = $counterId;
		}
		
		
		$rootElement = ArdeXml::fileRoot(  $twatch->path( 'store/'.$fileName ) );
		$fileInfo = TwatchImportFileInfo::fromXml( $rootElement );
		
		$dict = new TwatchDbPassiveDict( $twatch->db );
		
		$dbHistory = new TwatchDbHistory( $twatch->db, $website->getSub() );
		
		require_once $twatch->path( 'lib/Progress.php' );
		$progress = new TwatchProgress( $progressChannelId );
		$progress->start();
		
		$rowCount = 0;
		foreach( $fileInfo->counters as $impCounter ) {
			if( isset( $counterMap[ $impCounter->name ] ) ) {
				$counterId = $counterMap[ $impCounter->name ];
				$counter = $twatch->config->get( TwatchConfig::COUNTERS, $counterId );
				if( $counter->getType() != TwatchCounter::TYPE_SINGLE ) {
					$gene = $twatch->config->get( TwatchConfig::ENTITIES, $counter->entityId )->gene->getPassiveGene( $dict, TwatchEntityPassiveGene::MODE_NORMAL, TwatchEntityPassiveGene::CONTEXT_IMPORT );
				}
				$counterAvail = &$twatch->state->get( TwatchState::COUNTERS_AVAIL, $counterId );
				
				foreach( $impCounter->periodTypes as $periodTypeId => $periodType ) {
					$newTimestamps = array();
					if( isset( $counterAvail->timestamps[ $periodTypeId ] ) ) {
						$timestamps = $counterAvail->timestamps[ $periodTypeId ];
					} else {
						$timestamps = array();
					}
					if( !isset( $timestamps[0] ) || $fileInfo->periodTypes[ $periodTypeId ]->determinedStartTs < $timestamps[0] ) {
						$newTimestamps[] = $fileInfo->periodTypes[ $periodTypeId ]->determinedStartTs;
						if( !isset( $timestamps[0] ) || $fileInfo->periodTypes[ $periodTypeId ]->determinedStopTs < $timestamps[0] ) {
							$newTimestamps[] = $fileInfo->periodTypes[ $periodTypeId ]->determinedStopTs;
							if( isset( $timestamps[0] ) ) {
								$newTimestamps[] = $timestamps[0];
							}
						}
						for( $i = 1; $i < count( $timestamps ); ++$i ) {
							$newTimestamps[] = $timestamps[$i];
						}
					} else {
						$newTimestamps = $timestamps;
					}
					$counterAvail->timestamps[ $periodTypeId ] = $newTimestamps;
					if( $periodTypeId == TwatchPeriod::MONTH ) $counterAvail->timestamps[ TwatchPeriod::ALL ] = $newTimestamps;
					
					foreach( new ArdeXmlElemIter( $impCounter->element, TwatchPeriod::$typeImportTagNames[ $periodTypeId ] ) as $periodE ) {
						$period = TwatchPeriod::fromImportElement( $periodE );
						
						
						if( $period->getStartTs() > $fileInfo->periodTypes[ $period->type ]->determinedStopTs ) continue;
						if( $period->getEndTs() < $fileInfo->periodTypes[ $period->type ]->determinedStartTs ) continue;
						if( $counter->getType() == TwatchCounter::TYPE_SINGLE ) {
							++$rowCount;
							$progress->set( $fileInfo->rowCount == 0 ? 0 : $rowCount / $fileInfo->rowCount );
							
							$count = ArdeXml::intContent( $periodE );
							$counter->replace( $dbHistory, $period, $count ); 
							
							
						} else {
							$rows = array();
							foreach( new ArdeXmlElemIter( $periodE, 'row' ) as $rowE ) {
								++$rowCount;
								$progress->set( $fileInfo->rowCount == 0 ? 0 : $rowCount / $fileInfo->rowCount );
								
								$count = ArdeXml::intAttribute( $rowE, 'count' );
								$str = ArdeXml::strContent( $rowE );
								
								$entityVId = $gene->getStringEntityVId( $str, $website );
								if( $entityVId != false ) {
									$rows[ $entityVId ] = $count;
								}
								
								
							}
							$counter->replace( $dbHistory, $period, $rows );
						}
					}
					
					if( $periodTypeId == TwatchPeriod::MONTH ) {
						$q = "INSERT IGNORE INTO ".$twatch->db->tableName( 'h', $website->getSub() )
						." SELECT ".TwatchPeriod::ALL.", '', cid, p1, p2, SUM(c) FROM ".$twatch->db->tableName( 'h', $website->getSub() )
						." WHERE cid = ".$counter->id." AND dtt = ".TwatchPeriod::MONTH." GROUP BY p1, p2";
						$twatch->db->query( $q );
					}
				}
				
				$twatch->state->setInternal( TwatchState::COUNTERS_AVAIL, $counterId );

			}
		}
		if( !$xhtml ) {
			$p->pl( '<successful />' );
		}
	} else {
		throw new TwatchException( 'unknown action '.$_POST['a'] );
	}

	$p->end();
?>