<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	$adminConfig = true;
	require_once dirname(__FILE__).'/../../lib/RecGlobalHead.php';
	require_once dirname(__FILE__).'/../../data/DataLatest.php';
	
	loadConfig( array( TwatchLatestPage::$defaults ) );
	
	$latest = &$twatch->config->get( TwatchConfig::LATEST );
	$latestPage = &$twatch->config->get( TwatchConfig::LATEST_PAGE );
	
	if( !isset( $_POST['a'] )) throw new TwatchException( 'Action was not sent' );
	
	if( $_POST['a'] == 'change_latest' ) {

		$newLatest = TwatchLatest::fromParams( $_POST );
		if( $newLatest->isEquivalent( $latest ) ) throw new TwatchUserError( 'nothing to change' );
		$latest = $newLatest;
		$twatch->config->setInternal( TwatchConfig::LATEST );
		if( !$xhtml ) $p->pl( '<successful />' );
		
	} elseif( $_POST['a'] == 'restore_latest' ) {
		
		$twatch->config->restoreDefault( TwatchConfig::LATEST );
		if( !$xhtml ) {
			$latest->printXml( $p, 'result' );
			$p->nl();
		}
		
	} elseif( $_POST['a'] == 'change_page' ) {
	
		$newLatestPage = TwatchLatestPage::fromParams( $_POST );
		if( $newLatestPage->isEquivalent( $latestPage ) ) throw new TwatchUserError( 'nothing to change' );
		$latestPage = $newLatestPage;
		$twatch->config->setInternal( TwatchConfig::LATEST_PAGE );
		if( !$xhtml ) $p->pl( '<successful />' );
		
	} elseif( $_POST['a'] == 'restore_page' ) {
		
		$twatch->config->restoreDefault( TwatchConfig::LATEST_PAGE );
		if( !$xhtml ) {
			$latestPage->printXml( $p, 'result' );
			$p->nl();
		}
	
	} elseif( $_POST['a'] == 'cleanup' ) {
		
		$latest->cleanup();
		if( !$xhtml ) $p->pl( '<successful />' );
	
	} elseif( $_POST['a'] == 'reset' ) {	
		$twatch->config->get( TwatchConfig::COOKIE_KEYS )->upgradeKeys();
		$twatch->config->setInternal( TwatchConfig::COOKIE_KEYS );
		$latest->uninstall();
		$latest->install( true );
		if( !$xhtml ) $p->pl( '<successful />' );
		
	} else {
		throw new TwatchException( 'unknown action '.$_POST['a'] );
	}

	$p->end();
?>
