<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    
	require_once dirname(__FILE__).'/../lib/PageGlobal.php';
	require_once $twatch->path( 'lib/AdminPage.php' );
	
	$twatch->makeParentClass( 'AdminSearchEnginesPage', 'TwatchAdminPage' );
	
	class AdminSearchEnginesPage extends AdminSearchEnginesPageParent {
		
		public function render( ArdePrinter $p ) {
			global $twatch, $ardeBase;
			
			$this->toRoot = '..';
			$this->title = 'Admin: Search Engines';
		
			$this->init();
			
			$this->inHead->pl( '<script type="text/javascript" src="../js/PatternedObject.js"></script>' );
			$this->inHead->pl( '<script type="text/javascript" src="../js/SearchEngine.js"></script>' );
			
			$this->selected_left_button = 8;
			
			$this->open( $p );
			
			$p->pl( '<h1>Search Engines</h1>' );
			$p->pl( '<script type="text/javascript">/*<![CDATA[*/', 1 );
			$this->initJsPage( $p );
			$p->rel();
			$p->pl( '	searchEnginesHolder = new SearchEnginesHolder();' );
			$p->pl( '	searchEnginesHolder.insert();', 0 );
			foreach( $twatch->config->getList( TwatchConfig::SEARCH_ENGINES ) as $searchEngine ) {
				$p->pl( 'searchEnginesHolder.insertFirstItem( '.$searchEngine->jsObject().' )' );
			}
			$p->rel();
			$p->pl( '/*]]>*/</script>' );
			
			$this->close( $p );
		}
	}
	
	$twatch->applyOverrides( array( 'AdminSearchEnginesPage' => true ) );
	
	$page = $twatch->makeObject( 'AdminSearchEnginesPage' );
	$page->render( $p );
?>