<?php
	require_once dirname(__FILE__).'/lib/PageGlobal.php';
	
	$page->toRoot = '.';
	$page->title = 'Login';
	
	define( 'NO_POST_VARS', 0 );
	define( 'SUCCESSFUL_LOGIN', 1 );
	define( 'INVALID_USER', 2 );
	
	$status = NO_POST_VARS;
	
	if( isset( $_POST[ 'username' ] ) ) {
		
		$username = ArdeParam::str( $_POST, 'username' );
		$password = ArdeParam::str( $_POST, 'password' );
		
		$ardeUser->db = new ArdeDb( $ardeUser->settings );
		$ardeUser->db->connect();
		
		$user = ArdeUser::getUserByUnPass( $username, $password );
		
		if( $user === null ) {
			
			$status = INVALID_USER;
			
		} else {

			if( $user->random === null ) {
				$expires = 7*86400;
				$user->renewRandom( $expires );
			}
			
			
			setcookie( $ardeUser->settings[ 'cookie_prefix' ], $user->random, time() + $user->randomExpires, $ardeUser->settings[ 'cookie_folder' ], $ardeUser->settings[ 'cookie_domain' ] );

			
			$status = SUCCESSFUL_LOGIN;
			
			if( isset( $_GET[ 'back' ] ) ) {
				ardeRedirect( $_GET[ 'back' ] );
			}
		}
		
	}
	
	$p->crossPrinter->forceHold();	
	$p->start();
	$page->printFooter( $p->footer );
	$page->printHeader( $p );
	$p->crossPrinter->forceFlush();
	
	if( $status == SUCCESSFUL_LOGIN ) {
		$p->pl( '<p><span class="good">Successfully Logged In</span></p>' );
	} else {
		$p->pl( '<div class="block">' );
		$p->pl( '<form method="POST">' );
		$p->pl( '	<table class="form" cellpadding="0" cellspacing="0" border="0">' );
		$p->pl( '		<tr>' );
		$p->pl(	'			<td class="head">username:</td>' );
		$p->pl( '			<td class="tail">' );
		$p->pl( '				<input id="uninput" name="username" />' );
		$p->pl( '				<script type="text/javascript">/*<![CDATA[*/' );
		$p->pl( '					uninput = document.getElementById( "uninput" );' );
		$p->pl( '					uninput.focus();' );
		$p->pl( '				/*]]>*/</script>' );
		$p->pl( '			</td>' );
		$p->pl( '		</tr>' );
		$p->pl( '		<tr><td class="head">password:</td><td class="tail"><input name="password" type="password" /></td></tr>' );
		$p->pl( '	</table>' );
		$p->pl( '	<p><input type="submit" value="login" /></p>' );
		$p->pl( '</form>' );
		if( $status == INVALID_USER ) {
			$p->pl( '<p><span class="critical">Invalid Username or Password</span></p>' );	
		}
		$p->pl( '</div>' );
		$p->pl( '<p style="margin-top:0px;font-size:.9em"><b>TraceWatch</b> Web Stats, <span style="color:#060"><b>Free</b> Advanced Website Traffic Analysis</span> <a style="font-weight:bold" href="http://www.tracewatch.com/">www.TraceWatch.com</a></p>' );
		
	}
	
	$page->close( $p );
	
?>